Name:           perl-Test2-Plugin-UUID
%global cpan_version 0.002009
Version:        0.2.9
Release:        1%{?dist}
Summary:        Use real UUIDs in Test2
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Test2-Plugin-UUID
Source0:        https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Test2-Plugin-UUID-%{cpan_version}.tar.gz
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.10.0
BuildRequires:  perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
# Run-time:
BuildRequires:  perl(Carp)
BuildRequires:  perl(Test2::API) >= 1.302165
BuildRequires:  perl(Test2::Hub)
# Prefer UUID over Data::UUID::MT, UUID::Tiny, and Data::UUID to prevent
# Test2::Util::UUID from warning.
BuildRequires:  perl(UUID) >= 0.35
# Tests:
BuildRequires:  perl(IPC::Cmd)
BuildRequires:  perl(Test2::Require::Module) >= 0.000162
BuildRequires:  perl(Test2::Require::RealFork)
BuildRequires:  perl(Test2::Tools::Basic)
BuildRequires:  perl(Test2::Util::Table) >= 0.000162
BuildRequires:  perl(Test2::V0) >= 0.000162
Requires:       perl(Test2::API) >= 1.302165
Requires:       perl(Test2::Hub)
# Prefer UUID over Data::UUID::MT, UUID::Tiny, and Data::UUID to prevent
# Test2::Util::UUID from warning.
Requires:       perl(UUID) >= 0.35
# Removed from perl-Test2-Harness-0.001083
Conflicts:      perl-Test2-Harness < 0.001083

# Filter under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\(Test2::(API|Require::Module|Util::Table|V0)\\)$

%description
Test2 normally uses unique IDs generated by appending PID, thread ID, and an
incrementing integer. These work fine most of the time, but are not sufficient
if you want to keep a database of events, in that case a real UUID is much
more useful.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       perl-Test-Harness
Requires:       perl(Test2::API) >= 1.302165
Requires:       perl(Test2::Require::Module) >= 0.000162
Requires:       perl(Test2::Util::Table) >= 0.000162
Requires:       perl(Test2::V0) >= 0.000162

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Test2-Plugin-UUID-%{cpan_version}
# Help generators to recognize Perl scripts
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
unset TEST2_UUID_BACKEND TEST2_UUID_NO_WARN
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset TEST2_UUID_BACKEND TEST2_UUID_NO_WARN
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%doc Changes README
%dir %{perl_vendorlib}/Test2
%dir %{perl_vendorlib}/Test2/Plugin
%{perl_vendorlib}/Test2/Plugin/UUID.pm
%dir %{perl_vendorlib}/Test2/Util
%{perl_vendorlib}/Test2/Util/UUID.pm
%{_mandir}/man3/Test2::Plugin::UUID.*
%{_mandir}/man3/Test2::Util::UUID.*

%files tests
%{_libexecdir}/%{name}

%changelog
* Wed Aug 14 2024 Petr Pisar <ppisar@redhat.com> - 0.2.9-1
- 0.002009 bump

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Tue Jun 04 2024 Petr Pisar <ppisar@redhat.com> - 0.2.8-1
- 0.002008 bump

* Mon Jun 03 2024 Petr Pisar <ppisar@redhat.com> - 0.2.7-1
- 0.002007 bump

* Fri May 31 2024 Petr Pisar <ppisar@redhat.com> - 0.2.4-1
- 0.002004 bump

* Wed May 15 2024 Petr Pisar <ppisar@redhat.com> - 0.2.3-1
- 0.002003 bump

* Mon Apr 29 2024 Petr Pisar <ppisar@redhat.com> - 0.2.2-1
- 0.002002 bump
- Package the tests

* Thu Jan 25 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Sun Jan 21 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Jun 01 2022 Jitka Plesnikova <jplesnik@redhat.com> - 0.2.1-9
- Perl 5.36 rebuild

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri May 21 2021 Jitka Plesnikova <jplesnik@redhat.com> - 0.2.1-6
- Perl 5.34 rebuild

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jun 23 2020 Jitka Plesnikova <jplesnik@redhat.com> - 0.2.1-3
- Perl 5.32 rebuild

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Aug 19 2019 Petr Pisar <ppisar@redhat.com> 0.2.1-1
- Specfile autogenerated by cpanspec 1.78.
